#ifndef HEAP_H
#define HEAP_H

struct heap_header
{
	struct heap_header *next;
	size_t size;
	size_t vm_size;
};

typedef struct Heap Heap;

typedef struct
{
	void* (*claim)(Heap* heap, size_t* length);
	int (*release)(Heap* heap, void* address, size_t length);
}
HeapFunctions;

struct Heap
{
	struct heap_header free_list; /* start of free list */
	struct heap_header* scan_head; /* start point to scan */

	const HeapFunctions* fn;
};

extern void HeapInit(Heap* heap, const HeapFunctions* fns);
extern struct heap_header* HeapExtend(Heap* heap,
		void* address, size_t length);
extern void* HeapAlloc(Heap* heap, size_t length);
extern void HeapFree(Heap* heap, void* ptr);

#endif
