#ifndef MODULE_H
#define MODULE_H

/* R2's own module structure. */

typedef struct Module
{
	/* These two fields must be first, in this order. The SWI dispatcher
	 * is going to access them directly.
	 */

	quad userword;
	quad swi;

	struct Module* next;
	struct Module* prev;

	RO_Module* module;
	quad length;

	quad start;
	quad init;
	quad deinit;
	quad service;
	quad title;
	quad help;
	quad commandtable;
	quad swibase;
	quad swidecodetable;
	quad swidecode;
	quad messagetrans;

	unsigned external : 1;
}
Module;

/* Head of the linked list of modules. */

extern Module* ModuleList;

extern Module* FindModuleByName(const char* name);
extern Module* FindModuleByAddress(quad address);
extern Module* FindModuleBySWIBase(quad swi);
extern Module* FindModuleByCount(int count);

extern void InitRomModules(void);
extern Module* InsertModule(RO_Module* mo, size_t length);
extern void InitModule(Module* md);

#endif
