#ifndef R2_H
#define R2_H

#include "r2-consts.h"
#include "swimacros.h"

#ifndef NULL
#define NULL 0
#endif

typedef unsigned int size_t;
typedef unsigned int quad;

/* Standard error block. */

typedef struct
{
	int number;
	const char text[];
}
Error;

/* Register structure passed to routines called with cproxy. */

typedef struct
{
	quad r[16];
	quad swi;
}
Registers;

#define R0         R->r[0]
#define R1         R->r[1]
#define R2         R->r[2]
#define R3         R->r[3]
#define R4         R->r[4]
#define R5         R->r[5]
#define R6         R->r[6]
#define R7         R->r[7]
#define R8         R->r[8]
#define R9         R->r[9]
#define R10        R->r[10]
#define R11        R->r[11]
#define R12        R->r[12]
#define R13        R->r[13]
#define R14        R->r[14]
#define R15        R->r[15]

/* RISC OS module structure. */

typedef union RO_Module
{
	struct
	{
		quad start;
		quad init;
		quad deinit;
		quad service;
		quad title;
		quad help;
		quad commandtable;
		quad swibase;
		quad swi;
		quad swidecodetable;
		quad swidecode;
		quad messagetrans;
	} header;
	const char data[0];
}
RO_Module;

/* Assorted macro definitions. */

#if !defined offsetof
#define offsetof __builtin_offsetof
#endif

#endif
