#include "r2-asm.h"

.text

	/* The kernel's main entry points.
	 *
	 * _start + 0: init entry point
	 * _start + 4: SWI handler
	 */

.globl _start
_start:
	b kernel_init_entry_point
	b SWIDispatcher

kernel_init_entry_point:
	ldr r0, = _stack_start
	ldr r1, = _stack_end
	swi R2K_Init
	mov sp, r1

	/* Wipe BSS. */

	ldr r0, = __bss
	ldr r1, = 0
	ldr r2, = __end
	sub r2, r2, r0
	bl memset

	b start

.bss
.globl _stack_start, _stack_end
.align 4
_stack_start:
	.fill 64*1024
_stack_end:
