#include "r2k.h"

SYSCALL(Impl_ByteV)
{
	switch (R0)
	{
		case 126: /* Acknowledge escape condition */
		{
			/* FIXME: must call escape handler! */
			break;
		}

		case 161: /* Read CMOS */
		{
			switch (R1)
			{
				case 24: /* Territory */
					R2 = 0; /* UK minus 1 */
					break;

				default:
					printf("Unhandled CMOS read %d!\n", R1);
					abort();
			}
			break;
		}

		case 165: /* Read cursor position */
		{
			R1 = 0; // FIXME
			R2 = 0;
			break;
		}

		case 218: /* Read/write VDU queue length */
		{
			R1 = 0;
			break;
		}

		default:
		{
			printf("Unhandled OS_Byte %d!\n", R0);
			abort();
		}
	}

	return 0;
}

SYSCALL(Impl_OS_ReadVduVariables)
{
	quad* in = (quad*) R0;
	quad* out = (quad*) R1;

	for (;;)
	{
		quad op = *in++;

		switch (op)
		{
			case -1:
				return 0;

			case 256: /* get window width */
				op = 80;
				break;

			default:
				printf("Unhandled OS_ReadVduVariables %d!\n", op);
				abort();
		}

		*out++ = op;
	}

	return 0;
}

SYSCALL(Impl_OS_SynchroniseCodeAreas)
{
	if (R0 & 1)
		SWI2i0o(R2K_FlushCache, R1, R2);
	else
		SWI2i0o(R2K_FlushCache, 0, 0xefffffff);
	return 0;
}

SYSCALL(Impl_OS_ClaimSWI)
{
	printf("OS_ClaimSWI %x -> %x, %x\n", R0, R1, R2);
	SWITable[R0].routine = R1;
	SWITable[R0].r12 = R2;
	return 0;
}

SYSCALL(Impl_OS_ConvertCardinal)
{
	int count = itoa((char*) R1, R2, R0);
	R0 = R1;
	R1 = R0 + count;
	R2 = R2 - count;
	return 0;
}

SYSCALL(Impl_OS_AddCallback)
{
	printf("Warning: OS_AddCallback ignored\n");
	return 0;
}
