#include "r2k.h"

static void remove_from_vector(quad number, quad routine, quad r12)
{
	VectorDescriptor** chain = &VectorTable[number];
	VectorDescriptor* v = *chain;

	while (v)
	{
		VectorDescriptor** nextchain = &v->next;
		if ((v->routine == routine) && (v->r12 == r12))
		{
			*chain = *nextchain;
			free(v);
		}

		chain = nextchain;
		v = *chain;
	}
}

static void add_to_vector(quad number, quad routine, quad r12)
{
	VectorDescriptor* v = malloc(sizeof(VectorDescriptor));
	v->routine = routine;
	v->r12 = r12;
	v->next = VectorTable[number];
	VectorTable[number] = v;
}

SYSCALL(Impl_OS_Claim)
{
	printf("OS_Claim %x -> %x, %x\n", R0, R1, R2);

	remove_from_vector(R0, R1, R2);
	add_to_vector(R0, R1, R2);

	return 0;
}

