#include "r2-asm.h"

/* Vector table.
 *
 * This table stores the head node of each system vector. Each node has the
 * following structure:
 *
 *  +8 routine
 *  +4 r12 for this routine
 *  +0 next node, or NULL
 */

.data 4
proc VectorTable
	.word 0 // --- 0x00
	.word errorv_vector
	.word 0
	.word wrchv_vector
	.word 0
	.word 0
	.word bytev_vector
	.word 0
	.word filev_vector // 0x08
	.word argsv_vector
	.word 0
	.word 0
	.word 0
	.word findv_vector
	.word readlinev_vector
	.word 0
	.word 0 // --- 0x10
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0 // 0x18
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word changeenvironmentv_vector
	.word 0
	.word 0 // --- 0x20
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0 // 0x28
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0 // --- 0x30
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0 // 0x38
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0
	.word 0

errorv_vector:
	.word 0
	.word 0
	.word Impl_ErrorV

wrchv_vector:
	.word 0
	.word Impl_WrchV
	.word FCProxy

bytev_vector:
	.word 0
	.word Impl_ByteV
	.word FCProxy

argsv_vector:
	.word 0
	.word Impl_ArgsV
	.word FCProxy

filev_vector:
	.word 0
	.word Impl_FileV
	.word FCProxy

findv_vector:
	.word 0
	.word Impl_FindV
	.word FCProxy

readlinev_vector:
	.word 0
	.word Impl_ReadLineV
	.word FCProxy

changeenvironmentv_vector:
	.word 0
	.word Impl_ChangeEnvironmentV
	.word FCProxy

