#include "r2.h"
#include "libmodule.h"
#include "globals.h"

MODULETITLE("R2Supervisor");
MODULEHELP("R2 Supervisor\t21 October 2008");

ENTRYPOINT(ModuleStart, start);
int start(Registers* R)
{
	SWI1i0o(X|OS_Write0, "Supervisor\n\n");
	THROWE(0, "Supervisor not supported yet!");

	return 0;
}

ENTRYPOINT(CLIVHandler, cliv);
int cliv(Registers* R)
{
	const char* cmd = (const char*) R0;

	CommandBlock* cb;
	RO_Module* m;
	findCommand(cmd, &cb, &m);
	if (!cb)
		THROWE(0, "Bad command");

	Registers r;
	r.r[0] = (quad) cmd;
	r.r[1] = 0;
	r.r[12] = ModuleUserWord;
	r.r[15] = cb->routine + (quad) m;
	CallAsm(&r);

	return 0;
}

ENTRYPOINT(ModuleInit, init);
int init(Registers* R)
{
	SWI3i0o(X|OS_Claim, Vector_CliV, CLIVHandler, ModuleUserWord);
	return 0;
}

ENTRYPOINT(ModuleDeinit, deinit);
int deinit(Registers* R)
{
	return 0;
}
