#ifndef GLOBALS_H
#define GLOBALS_H

enum
{
	TYPE_GSONCE = 0,
	TYPE_NUMBER = 1,
	TYPE_GSALL = 2,
	TYPE_EXPRESSION = 3,
	TYPE_GSNEVER = 4,
	TYPE_CODE = 16
};

/* The API allows the user to refer to a variable directly by its name. For
 * this to work, the name must be embedded pretty much directly into the
 * variable structure --- unfortunately.
 */

typedef struct variable
{
	struct variable* next;
	struct variable* prev;
	void* data;
	size_t datalen;
	int type;
	char name[];
}
variable_t;

extern variable_t* variableListHead;

extern variable_t* findVariable(variable_t* var, const char* pattern);
extern void deleteVariable(variable_t* var);
extern variable_t* createVariable(const char* name, int type,
		const void* data, size_t datalen);

#endif
