#include "r2-asm.h"

/* Calls a machine code routine from C, nesting it on the current stack.
 * The r13 and r14 fields in the Registers structure will be overwritten.
 *
 * On entry:
 *   r0 = pointer to Registers structure
 *
 * Calls a vector, and then returns to lr.
 */

proc CallAsm
	stmfd sp!, {r4-r11, lr}       // C expects r4-r11 to be preserved
	push r0
	str r13, [r0, #13*4]
	adr r1, 0f
	str r1, [r0, #14*4]
	ldmia r0, {r0-r15}
0:
	pop lr
	stmia lr, {r0-r12}
	ldmfd sp!, {r4-r11, pc}
