class Bitmap
{
	typedef quad unit_t;
	static const int BIT = sizeof(unit_t) * 8;

public:
	Bitmap(int length)
	{
		_length_bits = length;
		_length_words = length / BIT;
		if (_length_words < 1)
			_length_words = 1;

		_data = new unit_t[_length_words];
		memset(_data, 0, sizeof(unit_t) * _length_words);
	}

	~Bitmap()
	{
		delete [] _data;
	}

private:
	unit_t& word_in_bitmap(unsigned int bit)
	{
		return _data[bit / BIT];
	}

	quad bit_in_word(unsigned int bit)
	{
		return 1 << (bit & (BIT-1));
	}

public:
	bool get(unsigned int bit)
	{
		return word_in_bitmap(bit) & bit_in_word(bit);
	}

	void set(unsigned int bit)
	{
		word_in_bitmap(bit) |= bit_in_word(bit);
	}

	void clr(unsigned int bit)
	{
		word_in_bitmap(bit) &= ~bit_in_word(bit);
	}

private:
	unit_t* _data;
	int _length_bits;
	int _length_words;
};
