#ifndef GLOBALS_H
#define GLOBALS_H

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <limits.h>

#include "sleevecc/sleeve.h"
#include "sleevecc/mm.h"

typedef uint32_t quad;

static const unsigned int KB = 1024;
static const unsigned int MB = 1024*KB;
static const unsigned int GB = 1024*MB;

extern arm_context context;

extern int singlestep();
extern void debugloop();

/* Virtual memory allocator. */

extern void vmalloc_init();
extern void vmalloc_release(quad address, quad length);
extern quad vmalloc_claim(quad length);

#endif
